// u_33_procedural_type
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_33_procedural_type;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    convert_integer_: TButton;
    convert_double_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure convert_integer_Click(Sender: TObject);
    procedure convert_double_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    Type t_pg_handle_two<T>= Procedure(p_one, p_two: T);

    procedure convert_two_integer(p_value, p_rate: Integer);
      begin
        display(Format('%4d    div %4d   = %d ',
            [p_value, p_rate, p_value Div p_rate]));
      end; // convert_two_integer

    procedure TForm1.convert_integer_Click(Sender: TObject);
      var l_pg_convert_two_integer: t_pg_handle_two<Integer>;
      begin
        l_pg_convert_two_integer:= convert_two_integer;
        l_pg_convert_two_integer(20, 3);
      end; // convert_integer_Click

    procedure convert_two_double(p_value, p_rate: Double);
      begin
        display(Format('%7.2f div %7.2f= %g ',
            [p_value, p_rate, p_value / p_rate]));
      end; // convert_two_double

    procedure TForm1.convert_double_Click(Sender: TObject);
      var l_pg_convert_two_double: t_pg_handle_two<Double>;
      begin
        l_pg_convert_two_double:= convert_two_double;
        l_pg_convert_two_double(20.0, 3.0);
      end; // convert_double_Click

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

